using System.Diagnostics.Metrics;
using System.Net.Http;
using Newtonsoft.Json.Linq;
namespace Frontend.Metrics;

public class EthMetrics{
    private readonly IMeterFactory _meterFactory;
    private ObservableGauge<double>? _totalSupplyGauge;

    public EthMetrics(IMeterFactory meterFactory)
    {
        _meterFactory = meterFactory;
    }

    public void CreateMetrics()
    {
        var meter = _meterFactory.Create("RoestiCoin");
        _totalSupplyGauge = meter.CreateObservableGauge("Ethereum.Price.Current", () => GetCurrentPriceInChf(), unit: "CHF");
    }

    public double GetCurrentPriceInChf(){
        string url = "https://min-api.cryptocompare.com/data/price?fsym=ETH&tsyms=CHF";
        using (HttpClient client = new HttpClient())
        {
            HttpResponseMessage response = client.GetAsync(url).Result;
            response.EnsureSuccessStatusCode();
            string responseBody = response.Content.ReadAsStringAsync().Result;
            JObject json = JObject.Parse(responseBody);
            double priceInChf = json["CHF"].Value<double>();
            return priceInChf;
        }
    
    }
}